name: qti-android-system-core
base: core20 # the base snap is the execution environment(core20) for this snap
version: '0.1'
summary: snap dependent libraries
description: |
  liblog, libcutils, safe-iop, libsync, libutils and libion

# Options: devel or stable
# devel: development version, not to be published in release channels
# stable: publish in release channels
grade: devel

# Options: devmode, strict, classic
# devmode: unrestricted access
# strict: restrict to the environment of snap only. Outside interaction using interfaces
# classic: not available for everyone. Community permissions needed
confinement: strict

#DEPENDS:

slots:
  android-system-core:
    interface: content
    content: lib0-2004
    read:
      - $SNAP/lib

parts:
  liblog:
    plugin: autotools
    source: $SNAPCRAFT_PROJECT_DIR/../../../src/system/core/
    source-subdir: liblog
    autotools-configure-parameters:
      - --sysconfdir=/snap/liblog
      - --with-core-includes=$SNAPCRAFT_PROJECT_DIR/../../../src/system/core/include
      - --with-logd-logging
    build-environment:
      - CFLAGS: "-I$SNAPCRAFT_PROJECT_DIR/../../../src/system/core/include"
      - CPPFLAGS: "-I$SNAPCRAFT_PROJECT_DIR/../../../src/system/core/include"
    build-packages:
      - build-essential
      - libglib2.0-dev
    stage-packages:
      - libglib2.0-dev
    prime:
      - -usr/local/lib/*.a
      - -usr/local/lib/*.la

  libcutils:
    plugin: autotools
    source: $SNAPCRAFT_PROJECT_DIR/../../../src/system/core/
    source-subdir: libcutils
    autotools-configure-parameters:
      - --sysconfdir=/snap/libcutiles
      - --with-core-includes=$SNAPCRAFT_PROJECT_DIR/src/include
    build-environment:
      - CFLAGS: "-I$SNAPCRAFT_PROJECT_DIR/../../../src/system/core/include"
      - CPPFLAGS: "-I$SNAPCRAFT_PROJECT_DIR/../../../src/system/core/include"
      - LDFLAGS:  "-L$SNAPCRAFT_STAGE/usr/local/lib/"
    build-packages:
      - build-essential
      - pkg-config
    prime:
      - -usr/local/lib/*.a
      - -usr/local/lib/*.la
    after:
      - liblog

  safe-iop:
    plugin: autotools
    source: $SNAPCRAFT_PROJECT_DIR/../../../src/external/safe-iop
    override-pull: |
      snapcraftctl pull
      patch -p1 < $SNAPCRAFT_PROJECT_DIR/patches/safe_iop-autotool.patch
    autotools-configure-parameters:
      - --sysconfdir=/snap/safe-iop
    build-packages:
      - build-essential
    prime:
      - -usr/local/lib/*.a
      - -usr/local/lib/*.la

  libutils:
    plugin: autotools
    source: $SNAPCRAFT_PROJECT_DIR/../../../src/system/core/
    source-subdir: libutils
    autotools-configure-parameters:
      - --sysconfdir=/snap/libutiles
      - --with-system-core-includes=$SNAPCRAFT_PROJECT_DIR/src/include
      - --with-liblog-includes=$SNAPCRAFT_PROJECT_DIR/src/liblog
    build-environment:
      - CFLAGS: "-I$SNAPCRAFT_PROJECT_DIR/../../../src/system/core/include \
                 -I$SNAPCRAFT_PROJECT_DIR/../../../src/external/safe-iop/include"
      - CPPFLAGS: "-I$SNAPCRAFT_PROJECT_DIR/../../../src/system/core/include \
                   -I$SNAPCRAFT_PROJECT_DIR/../../../src/external/safe-iop/include"
    build-packages:
      - build-essential
    prime:
      - -usr/local/lib/*.a
      - -usr/local/lib/*.la
    after:
      - safe-iop

  libsync:
    plugin: autotools
    source: "git://source.codeaurora.org/quic/la/platform/system/core/"
    source-type: git
    source-subdir: libsync
    source-commit: 8fbe56b11ee7c1f8c87e9b71d89caa306c6cdebb
    override-pull: |
      snapcraftctl pull
      patch -p1 < $SNAPCRAFT_PROJECT_DIR/patches/libsync-autotool.patch
    autotools-configure-parameters:
      - --sysconfdir=/snap/libsync
      - --with-glib
    build-environment:
      - LDFLAGS:  "-L$SNAPCRAFT_STAGE/usr/local/lib/"
    build-packages:
      - build-essential
      - libglib2.0-dev
    stage-packages:
      - libglib2.0-dev
    prime:
      - -usr/local/lib/*.a
      - -usr/local/lib/*.la
    after:
      - liblog

  libion:
    plugin: autotools
    source: $SNAPCRAFT_PROJECT_DIR/../../../src/system/core/
    source-subdir: libion
    autotools-configure-parameters:
      - --sysconfdir=/snap/libion
      - --with-core-includes=$SNAPCRAFT_PROJECT_DIR/src/include
    build-environment:
      - CFLAGS: "-I$SNAPCRAFT_PROJECT_DIR/../../../src/system/core/include \
                 -I$SNAPCRAFT_PROJECT_DIR/../../../kernel-headers/usr/include/ \
                 -I$SNAPCRAFT_STAGE"
      - CPPFLAGS: "-I$SNAPCRAFT_PROJECT_DIR/../../../src/system/core/include \
                   -I$SNAPCRAFT_STAGE"
      - LDFLAGS:  "-L$SNAPCRAFT_STAGE/usr/local/lib/"
    prime:
      - -usr/local/lib/*.a
      - -usr/local/lib/*.la
    after:
      - liblog
      - libutils
      - libcutils
      - libsync
    override-prime: |
      snapcraftctl prime
      cd $SNAPCRAFT_PRIME
      tar -cf $SNAPCRAFT_PROJECT_DIR/qti-android-system-core.tar .
      mkdir -p $SNAPCRAFT_PROJECT_DIR/../../../out
      cp $SNAPCRAFT_PROJECT_DIR/qti-android-system-core.tar $SNAPCRAFT_PROJECT_DIR/../../../out/
